summaryrefslogtreecommitdiff
path: root/tests/rm/fail-eacces
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2006-12-20 19:56:20 +0100
committerJim Meyering <jim@meyering.net>2006-12-21 08:58:11 +0100
commitc8ef95eaed944ec70ccd70c077cf465c6311c1b6 (patch)
tree5c83a1915419c58457fff59afe894abf3e00471c /tests/rm/fail-eacces
parentd69fc66d81c7166fe689418f42b7cb900d2a1433 (diff)
downloadcoreutils-c8ef95eaed944ec70ccd70c077cf465c6311c1b6.tar.xz
"rm -rf /etc/motd" (run by non-root) now prints a diagnostic.
* src/remove.c (remove_entry): Handle EACCES for a non-directory, too. Karl Berry reported that a cross-partition "mv /etc/issue ~" failed with the um,... suboptimal diagnostic, "mv: cannot remove `/etc/issue': Not a directory". * tests/rm/Makefile.am (TESTS): Add fail-eacces. * tests/rm/fail-eacces: New file. * NEWS: Mention that both mv and rm are affected.
Diffstat (limited to 'tests/rm/fail-eacces')
-rwxr-xr-xtests/rm/fail-eacces53
1 files changed, 53 insertions, 0 deletions
diff --git a/tests/rm/fail-eacces b/tests/rm/fail-eacces
new file mode 100755
index 000000000..29bc91154
--- /dev/null
+++ b/tests/rm/fail-eacces
@@ -0,0 +1,53 @@
+#!/bin/sh
+# Ensure that rm -rf unremovable-non-dir gives a diagnostic.
+
+# Copyright (C) 2006 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ rm --version
+fi
+
+. $srcdir/../lang-default
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir d && touch d/f && chmod a-w d || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+rm -rf d/f 2> out && fail=1
+cat <<\EOF > exp
+rm: cannot remove `d/f': Permission denied
+EOF
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail